searchNodes=[{"doc":"A GenStage Producer for Redis Stream. Broadway producer acts as a consumer in the specified Redis stream consumer group. You can run multiple consumers to get better throughput and fault tolerance. Please check Redis Stream Intro for details on stream data type. It supports failover by automatically claiming pending messages when a node dies. A node is considered dead when it fails to send heartbeats. Currently, it only supports Redis 6.0.2 and above Producer Options :redis_client_opts - Required. Redis client specific options. Default client is Redix and for Redix this is used to start redix process Redix.start_link(opts) . see Redix Documentation :receive_interval - Optional. The duration (in milliseconds) for which the producer waits before making a request for more messages if there are no events in stream. Default is 1000 . :stream - Required. Redis stream name :group - Required. Redis consumer group. Group will be created with :group_start_id ID if it is not already present. :group_start_id - Optional. Starting stream ID which should be used when consumer group created . Use $ for latest ID. see XGROUP CREATE . Default is $ :consumer_name - Required. Redis consumer name for the Broadway instance in the consumer-group. If you are running multiple consumers, make sure that each consumer has unique name. :heartbeat_interval - Optional. Producer sends heartbeats at regular intervals, this is interval duration. Default is 5000 :allowed_missed_heartbeats - Optional. Number of allowed missing heartbeats for a consumer. The consumer is considered to be dead after this and other consumers claim its pending messages. Default is 3 :make_stream - Optional. Appends MKSTREAM subcommand to XGROUP CREATE which automatically create the stream if it doesn't exist. See XGROUP CREATE . Default is false delete_on_acknowledgment - Optional. When XACK ing a message also XDEL ete it. Defaults to false Acknowledgements Both successful and failed messages are acknowledged by default. Use Broadway.Message.configure_ack/2 to change this behaviour for failed messages. If a message configured to retry, that message will be attempted again in next batch. if message . metadata . attempt &lt; @max_attempts do Message . configure_ack ( message , retry : true ) else message end attempt field in metadata can be used to control maximum retries. use handle_failure callback to handle failures by moving messages to other stream or persisting failed jobs etc Message Data Message data is a 2 element list. First item is id of the message, second is the data Retry After If message.metadata.retry_after is present and represents a unix timestamp (in milliseconds) in the future then the message will not be retried until after the time has passed. This is useful for when you are using off_broadway_redis_stream to talk to third party apis that may rate limit you and you need to back off from sending requests.","ref":"OffBroadwayRedisStream.Producer.html","title":"OffBroadwayRedisStream.Producer","type":"module"},{"doc":"A Redis Stream consumer for Broadway . Broadway producer acts as a consumer in the specified Redis stream consumer group. You can run multiple consumers to get better throughput and fault tolerance. Please check Redis Stream Intro for details on stream data type. It supports failover by automatically claiming pending messages when a node dies. A node is considered dead when it fails to send heartbeats. defmodule MyBroadway do use Broadway def start_link ( _opts ) do Broadway . start_link ( __MODULE__ , name : __MODULE__ , producer : [ module : { OffBroadwayRedisStream.Producer , [ redis_client_opts : [ host : &quot;localhost&quot; ] , stream : &quot;orders&quot; , group : &quot;processor-group&quot; , consumer_name : hostname ( ) ] } ] , processors : [ default : [ min_demand : 5 , max_demand : 1000 ] ] ) end def handle_message ( _ , message , _ ) do [ _id , key_value_list ] = message . data IO . inspect ( key_value_list , label : &quot;Got message&quot; ) message end @max_attempts 5 def handle_failed ( messages , _ ) do for message &lt;- messages do if message . metadata . attempt &lt; @max_attempts do Broadway.Message . configure_ack ( message , retry : true ) else [ id , _ ] = message . data IO . inspect ( id , label : &quot;Dropping&quot; ) end end end defp hostname do { :ok , host } = :inet . gethostname ( ) to_string ( host ) end end Currently, it only supports Redis 6.0.2 and above.","ref":"readme.html","title":"OffBroadwayRedisStream","type":"extras"},{"doc":"def deps do [ { :off_broadway_redis_stream , &quot;~&gt; x.x.x&quot; } ] end License Copyright (c) 2021 Akash Hiremath. OffBroadwayRedisStream source code is released under Apache License 2.0. Check LICENSE for more information.","ref":"readme.html#installation","title":"OffBroadwayRedisStream - Installation","type":"extras"},{"doc":"Apache License Version 2.0 , January 2004 http :// www . apache . org / licenses / TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License ; and (b) You must cause any modified files to carry prominent notices stating that You changed the files ; and (c) You must retain, in the Source form of any Derivative Works that You distribute , all copyright , patent , trademark , and attribution notices from the Source form of the Work , excluding those notices that do not pertain to any part of the Derivative Works ; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution , then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file , excluding those notices that do not pertain to any part of the Derivative Works , in at least one of the following places : within a NOTICE text file distributed as part of the Derivative Works ; within the Source form or documentation , if provided along with the Derivative Works ; or , within a display generated by the Derivative Works , if and wherever such third - party notices normally appear . The contents of the NOTICE file are for informational purposes only and do not modify the License . You may add Your own attribution notices within Derivative Works that You distribute , alongside or as an addendum to the NOTICE text from the Work , provided that such additional attribution notices cannot be construed as modifying the License . You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS","ref":"license.html","title":"LICENSE","type":"extras"}]